#include "libasus.h"

int libasus_init(int enable_debug) {

  debug = enable_debug;

  /* WARNING: This function no longer detects cards for you */

  if (!init_nvclock()) { printf("1\n"); return false; }
  if (!set_card(0)) { printf("2\n"); return false; }
  NVLockUnlock(0);    // Unlock the CRTC registers

  return true;
}

int libasus_get_gpu_temp(libasus_card card) {
  return card.get_gpu_temp(card.card);
}

int libasus_get_ram_temp(libasus_card card) {
  return card.get_ram_temp(card.card);
}

int libasus_get_gpu_fanspeed(libasus_card card) {
  return card.get_gpu_fanspeed(card.card);
}

int libasus_set_gpu_fanspeed(libasus_card card, int desired_rpm) {
  return card.set_gpu_fanspeed(card.card, desired_rpm);
}

int libasus_get_gpu_fanmode(libasus_card card) {
  return card.get_gpu_fanmode(card.card);
}

int libasus_set_gpu_fanmode(libasus_card card, I2CByte mode) {
  return card.set_gpu_fanmode(card.card, mode);
}

int libasus_set_gpu_pwmspeed(libasus_card card, int speed) {
  return card.set_gpu_pwmspeed(card.card, speed);
}

int libasus_get_gpu_pwmspeed(libasus_card card) {
  return card.get_gpu_pwmspeed(card.card);
}

int libasus_set_gpu_tempctl(libasus_card card, fan_vtemp speeds) {
  return card.set_gpu_tempctl(card.card, speeds);
}

int libasus_get_gpu_tempctl(libasus_card card, fan_vtemp *speeds) {
  return card.get_gpu_tempctl(card.card, speeds);
}
